/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

int main (int argc, char **argv) {
    int i;

    /* Remember original ac/av/ep */
    org_argc = argc;
    org_argv = argv;

    /* Inherit program options and configuration */
    options_read (0);
    config_read (0);

    /* Convert the log facility number into a syslog constant. */
    switch (opt.log_facility) {
    case 0:
	opt.log_facility = LOG_LOCAL0;
	break;
    case 1:
	opt.log_facility = LOG_LOCAL1;
	break;
    case 2:
	opt.log_facility = LOG_LOCAL2;
	break;
    case 3:
	opt.log_facility = LOG_LOCAL3;
	break;
    case 4:
	opt.log_facility = LOG_LOCAL4;
	break;
    case 5:
	opt.log_facility = LOG_LOCAL5;
	break;
    case 6:
	opt.log_facility = LOG_LOCAL6;
	break;
    case 7:
	opt.log_facility = LOG_LOCAL7;
	break;
    default:
	opt.log_facility = LOG_DAEMON;
	break;
    }
    
    /* We're the daemon executable. We know what to do -- serve. */
    msg ("Starting services");
    for (i = 0; i < nservice; i++) {
	/* Start the service. */
	activeservice = service + i;
	runservice ();
    }

    /* All done. */
    return (0);
}
