<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>

<xsl:template match="/">
 <html>
  <head>
   <title>Crossroads Status Overview</title>
   <script type="text/javascript">
     function setstate (target, index) {
       document.location = '/set/' + target + '/state/' + index;
     }
     function setaddress (target) {
       var hostname = document.getElementById (target + '/hostname').value;
       var port     = document.getElementById (target + '/port').value;
       document.location = '/set/' + target + '/server/' +
	   hostname + '/' + port;
     }
   </script>
   <style type="text/css">
     h1 {
       font-family: Verdana,Helvetica;
       font-size: 12pt;
       color: blue;
     }
     body {
       font-family: Verdana,Helvetica;
       font-size: 8pt;
     }
     td {
       font-family: Verdana,Helvetica;
       font-size: 10pt;
     }
     .service { background-color: #ffff33; }
     .backend { background-color: #ffff99; }
     .info { font-size: 8pt; }
     .footer { color: gray; }
   </style>
  </head>
  <body>
   <h1>Crossroads Status Overview</h1>
   <hr/>
   <form>
    <xsl:apply-templates/>
   </form>
   <hr/>
    <div class="footer">
      <i>
	Generated by Crossroads __VER__.
	Visit
	<a href="http://crossroads.e-tunity.com">
	  http://crossroads.e-tunity.com
	</a>
	for documentation and downloads. <br/>
      </i>
    </div>
  </body>
 </html>
</xsl:template>

<xsl:template match="/status">
 <table width="100%">
  <xsl:apply-templates/>
 </table>
</xsl:template>

<xsl:template match="/status/service">
 <tr>
  <td class="service" valign="top">
    <b> Service  <xsl:value-of select="@name"/> </b>
  </td>
  <td class="service" colspan="3">
    <table>
      <tr>
	<td class="service">Total connections:</td>
	<td class="service"><xsl:value-of select="connections"/></td>
      </tr>
      <xsl:if test="backends_available &gt; 0">
	<tr>
	  <td class="service">Available back ends:</td>
	  <td class="service"><xsl:value-of select="backends_available"/></td>
	</tr>
      </xsl:if>
      <xsl:if test="backends_unavailable &gt; 0">
	<tr>
	  <td class="service">Unvailable back ends:</td>
	  <td class="service"><xsl:value-of select="backends_unavailable"/></td>
	</tr>
      </xsl:if>
      <xsl:if test="backends_down &gt; 0">
	<tr>
	  <td class="service">Down back ends:</td>
	  <td class="service"><xsl:value-of select="backends_down"/></td>
	</tr>
      </xsl:if>
      <xsl:if test="backends_waking &gt; 0">
	<tr>
	  <td class="service">Waking back ends:</td>
	  <td class="service"><xsl:value-of select="backends_waking"/></td>
	</tr>
      </xsl:if>
      <tr>
	<td class="service">Listener process PID:</td>
	<td class="service"><xsl:value-of select="pid"/></td>
      </tr>
    </table>
  </td>
 </tr>
 <xsl:apply-templates/>
 <tr> </tr>
</xsl:template>

<xsl:template match="/status/service/backend">
 <tr>
  <td width="15%"> </td>
  <td class="backend" width="15%"> Back end </td>
  <td class="backend" width="15%"> <b> <xsl:value-of select="@name"/> </b> </td>
  <td class="backend">
    <select onchange="setstate('{../@name}/{@name}', this.selectedIndex);">
      <xsl:choose>
	<xsl:when test="availability/@id = 0">
	  <option value="available" selected="1">available</option>
	</xsl:when>
	<xsl:otherwise>
	  <option value="available">available</option>
	</xsl:otherwise>
      </xsl:choose>
      <xsl:choose>
	<xsl:when test="availability/@id = 1">
	  <option value="unavailable" selected="1">unavailable</option>
	</xsl:when>
	<xsl:otherwise>
	  <option value="unavailable">unavailable</option>
	</xsl:otherwise>
      </xsl:choose>
      <xsl:choose>
	<xsl:when test="availability/@id = 2">
	  <option value="down" selected="1">down</option>
	</xsl:when>
	<xsl:otherwise>
	  <option value="down">down</option>
	</xsl:otherwise>
      </xsl:choose>
      <xsl:choose>
	<xsl:when test="availability/@id = 3">
	  <option value="waking" selected="1">waking</option>
	</xsl:when>
	<xsl:otherwise>
	  <option value="waking">waking</option>
	</xsl:otherwise>
      </xsl:choose>
      <xsl:choose>
	<xsl:when test="availability/@id = 4">
	  <option value="intermediate" selected="1">intermediate</option>
	</xsl:when>
	<xsl:otherwise>
	  <option value="intermediate">intermediate</option>
	</xsl:otherwise>
      </xsl:choose>
      <xsl:choose>
	<xsl:when test="availability/@id = 5">
	  <option value="unknown" selected="1">unknown</option>
	</xsl:when>
	<xsl:otherwise>
	  <option value="unknown">unknown</option>
	</xsl:otherwise>
      </xsl:choose>
    </select>
  </td>
 </tr>
 <tr>
   <td class="info"/>
   <td class="info"/>
   <td class="info"> Address: </td>
   <td class="info">
     <input name="{../@name}/{@name}/hostname" type="text" class="info"
	    id="{../@name}/{@name}/hostname" value="{server}" maxlength="255"/>
     :
     <input name="{../@name}/{@name}/port" type="text" value="{port}"
	    id="{../@name}/{@name}/port" size="7" class="info"/>
     <input type="button" class="info" value="Set"
      onclick="setaddress('{../@name}/{@name}');"/>
   </td>
 </tr>
 <tr>
   <td class="info"/>
   <td class="info"/>
   <td class="info"> Connections: </td>
   <td class="info">
     Total <xsl:value-of select="connections"/>
     (<xsl:value-of select="failures"/> failures,
      <xsl:value-of select="clients"/> active)
   </td>
 </tr>
 <tr>
   <td class="info"/>
   <td class="info"/>
   <td class="info"> Usage: </td>
   <td class="info">
     Throughput
     <b><xsl:value-of select="throughput"/></b> in 
     <b><xsl:value-of select="duration"/></b>,
     <b><xsl:value-of select="lastaccess"/></b> ago
   </td>
 </tr>
 <xsl:apply-templates/>
</xsl:template>

<xsl:template match="*"/>

</xsl:stylesheet>
