/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

int backend_available (int target) {
    /* Backend is available when:
     * (a) The state indicates availability;
     * (b) Either, there is no max to the active connections, or
     *     the # of connections is below the max.
     */
    if (servicereport->backendstate[target].actual_avail == st_available &&
	(activeservice->backend[target].maxconnections == 0 ||
	 activeservice->backend[target].maxconnections >
	 servicereport->backendstate[target].nclients)) {
	msg ("Backend %s is available", activeservice->backend[target].name);
	return (1);
    }

    msg ("Bckend %s is unavailable", activeservice->backend[target].name);
    return (0);
}
