/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "../crossroads.h"

int cmd_stop (int ac, char **av) {
    int i, result = 0;

    for (i = 0; i < nservice; i++) {
	alloc_reporter (service + i, 0);
	msg ("Stopping service %s (daemon pid %d, wakeup handler pid %d)",
	     service[i].name, servicereport->pid, servicereport->rev_pid);
	if (kill (servicereport->pid, SIGINT)) {
	    warning ("Failed to stop service %s (%s)",
		     service[i].name, strerror(errno));
	    result++;
	} else if (servicereport->rev_pid &&
		   kill (servicereport->rev_pid, SIGINT)) {
	    warning ("Failed to stop wakeup handler of service %s (%s)",
		     service[i].name, strerror(errno));
	    result++;
	}
	
	/* Note: We run the deallocator of shmem here anyway, though the
	 * signalled listener does it too.. just to make sure.. We do this
	 * only if above kills have succeeded.
	 */
	if (!result)
	    dealloc_reporter (service + i);
    }

    return (1);
}
