/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#define EXTERN
#include "../crossroads.h"

/* Global data for all Crossroads programs */

Options opt = {
    0,				/* log_activity */
    DEFAULT_TCP_BUFSZ,		/* tcp_bufsz */
    DNS_CACHETTL,		/* dns_cachettl */
    LOG_DAEMON,			/* log_facility */
    
    0644,			/* shmperm */
    0,				/* sloppyportbind */
    0,				/* leave_proctitle */
    0,				/* log_http_activity */
};

StateStringMap statestringmap[] = {
    { st_available, 			"available" },
    { st_available, 			"up" },
    { st_unavailable, 			"unavailable" },
    { st_down, 				"down" },
    { st_waking, 			"waking" },
    { st_intermediate, 			"intermediate" },
    { st_unknown, 			"unknown" },
    { st_unknown, 			0 }
};

int relevant_sigs[] = {			/* signals relevant to this app */
    SIGHUP,				/* either caught or ignored, */
    SIGINT,				/* depending on the stage */
    SIGQUIT,
    SIGABRT,
    SIGKILL,
    SIGPIPE,
    SIGTERM,
    0,
};

DnsCache dnscache[DNS_CACHESIZE];	/* The DNS cache */
