/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

void decr_client_count () {
    unsigned totclients = 0;
    int i;
    
    if (program_stage != stage_serving)
	return;
    
    lock_reporter();
    
    for (i = 0; i < activeservice->nbackend; i++)
	totclients += servicereport->backendstate[i].nclients;
    servicereport->nclients = totclients;
    msg ("total active clients now %u", totclients);

    /* Warning: Use current_backend as index only if >= 0; it
     * may be -1 when still searching for an HTTP back end */
    if (current_backend >= 0 && 
	servicereport->backendstate[current_backend].nclients > 0)
	servicereport->backendstate[current_backend].nclients--;

    unlock_reporter();

    if (current_backend >= 0) {
	msg ("extcmd-onend: "
	     "current_backend = %d, clients = %d, "
	     "totclients = %d, cmd = %s",
	     current_backend,
	     servicereport->backendstate[current_backend].nclients,
	     servicereport->nclients, 
	     activeservice->backend[current_backend].onend ?
	     activeservice->backend[current_backend].onend : "<none>");

	sysrun (activeservice->backend[current_backend].onend);
    }
}
