/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

void expand_program_name (char const *av0) {
    char *str, *cp, *last = (char*)expand_program_name;
    
    /* If we have path separators, then assume it's already expanded. */
    if (strchr (av0, '/')) {
	program_name = xstrdup (av0);
	return;
    }

    /* Try to locate av0 along the PATH */
    str = xstrdup(getenv("PATH"));
    for (cp = strtok_r (str, ":", &last); cp; cp = strtok_r (0, ":", &last)) {
	free (program_name);
	program_name = str_printf ("%s/crossroads", cp);
	if (!access (program_name, R_OK | X_OK))
	    return;
    }

    /* All PATHs failed. Run back to av0. */
    free (program_name);
    program_name = xstrdup(av0);
}
