/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

/* #define DEBUG */

#ifdef DEBUG
static void debughdr (HttpHeader *h) {
    int i;
    msg ("http header add: %d headers so far", h->nheader);
    for (i = 0; i < h->nheader; i++)
	msg ("http header add: header[%d] '%s'",
	     i, h->header[i]);
}

#define SHOWHEADERS(h)  debughdr((h))
#else
#define SHOWHEADERS(h)
#endif

void http_header_addheader (HttpHeader *m, char const *h) {
    char *exp;

    exp = str_expand_format (h);
    msg ("adding header '%s'", exp);
    m->header = xrealloc (m->header, (m->nheader + 1) * sizeof(char*));
    m->header[m->nheader++] = exp;
    SHOWHEADERS(m);
}
