/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "../crossroads.h"

void http_header_appendheader (HttpHeader *m, char const *h) {
    char *hname, *cp, *exp;
    int i;
    
    hname = xstrdup (h);
    if (! (cp = strchr (hname, ':')) ) {
	free (hname);
	return;
    }
    *cp = 0;
    cp++;

    while (is_space (*cp) || *cp == ':')
	cp++;
    exp = str_expand_format (cp);
    
    for (i = 0; i < m->nheader; i++) {
	if (!m->header[i] || !*m->header[i])
	    continue;
	/* msg ("Append header: comparing '%s' to '%s'",
	     hname, m->header[i]); */
	
	if (!strncasecmp (m->header[i], hname, strlen(hname))) {
	    m->header[i] = xstrcat (m->header[i], "; ");
	    m->header[i] = xstrcat (m->header[i], exp);
	    /* msg ("appending (after existing) header, now '%s'",
	        m->header[i]); */
	    free (hname);
	    return;
	}
    }

    /*  msg ("appending (setting) header '%s'", h); */
    
    http_header_addheader (m, h);
}
