/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "../crossroads.h"

HttpConnectionType http_header_connectiontype (HttpHeader *h) {
    unsigned char const *val;

    if (! (val = http_header_val (h, "proxy-connection")) )
	val = http_header_val (h, "connection");

    if (!val) {
	msg ("Cannot determine connection type, no such header");
	return (con_unknown);
    }
    if (strcasestr ((char const *)val, "close")) {
	msg ("Connection-Type is CLOSE");
	return (con_close);
    } else if (strcasestr ((char const *)val, "keep-alive")) {
	msg ("Connection-Type is KEEP-ALIVE");
	return (con_keepalive);
    }
    warning ("Unsupported Connection-Type '%s'", val);
    return (con_unknown);
}
