/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "../crossroads.h"

int http_header_hascookie (HttpHeader *m, char const *cookie) {
    unsigned char const *val;
    char *cp, *buf;
    
    if (!cookie || !*cookie)
	return (0);
    if (! (val = http_header_val (m, "cookie")) ) {
	msg ("no cookies in HTTP message");
	return (0);
    }

    buf = xstrdup ((char const *) val);
    for (cp = buf; cp && *cp; cp = strchr (cp, ';')) {
	while (*cp == ';' || *cp == ' ')
	    cp++;
	if (!strncmp (cp, cookie, strlen (cookie))) {
	    msg ("found cookie '%s' in '%s'", cookie, buf);
	    free (buf);
	    return (1);
	}
    }
    msg ("cookie '%s' not present in '%s'", cookie, buf);
    free (buf);
    return (0);
}
