/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "../crossroads.h"

double http_header_httpver (HttpHeader *h) {
    double ret;
    
    /* We need at least a header line */
    if (h->nheader < 1) {
	warning ("cannot get HTTP version, no headers");
	return (0.9);
    }

    /* We need HTTP/1.? length */
    if (strlen (h->header[0]) < 8) {
	warning ("cannot get HTTP version, header line '%s'", h->header[0]);
	return (0.9);
    }
    
    /* If the line starts with HTTP then it's a server line.
     * Otherwise it's a client line. */
    if (!strncmp (h->header[0], "HTTP/", 5))
	ret = atof (h->header[0] + 5);
    else
	ret = atof (h->header[0] + strlen(h->header[0]) - 3);
    
    msg ("HTTP version is %g (headerline %s)", ret, h->header[0]);
    return (ret);
}
	       
