/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "../crossroads.h"

void http_header_setheader (HttpHeader *m, char const *h) {
    int i;
    char *hname, *cp, *exp;

    hname = xstrdup (h);
    if (! (cp = strchr (hname, ':')) ) {
	free (hname);
	return;
    }
    *cp = 0;

    exp = str_expand_format (h);
    for (i = 0; i < m->nheader; i++) {
	if (!m->header[i] || !*m->header[i])
	    continue;
	if (!strncasecmp (m->header[i], hname, strlen(hname))) {
	    free (m->header[i]);
	    msg ("setting (replacing) header '%s'", exp);
	    m->header[i] = exp;
	    free (hname);
	    return;
	}
    }

    msg ("setting (adding) header '%s'", exp);
    m->header = xrealloc (m->header, (m->nheader + 1) * sizeof(char*));
    m->header[m->nheader++] = exp;
    free (hname);
}
