/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "../crossroads.h"

void http_header_write (HttpHeader *m, int sock, CopyDirection dir) {
    int i;

    msg ("Sending %d HTTP headers to %s",
	 m->nheader, 
	 dir == dir_server_to_client ? "client" : "server");
    
    for (i = 0; i < m->nheader; i++) {
	if (! m->header[i] || ! *m->header[i])
	    continue;
	/*
	msg ("sending header %d: '%s'",
	     i, m->header[i]);
	*/
	http_write (sock, dir, (unsigned char const *) m->header[i],
		    strlen(m->header[i]));
	http_write (sock, dir, (unsigned char const *) "\r\n", 2);
    }
    http_write (sock, dir, (unsigned char const *) "\r\n", 2);
}
