/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "../crossroads.h"

void http_insert_header (unsigned char **bufp, unsigned *buflen,
			 char const *header) {
    unsigned char const *buf, *cp;
    unsigned char *newbuf;
    char *instruction;
    int crseen = 0, atend = 0;       

    cp = buf = *bufp;
    msg ("Pasting header '%s' in '%s'", header, buf);
    while (1) {
	if (*cp == '\n')
	    cp++;
	if (! (cp = (unsigned char const *)
	        strchr ( (char const *) cp, '\n')) ) {
	    msg ("Failed to find end of headers while inserting header");
	    return;
	}
	cp++;
	
	if (*cp == '\r') {
	    crseen++;
	    if (*(cp + 1) == '\n')
		atend++;
	} else if (*cp == '\n')
	    atend++;

	if (atend) {
	    instruction = str_printf ("%s%s",
				      header,
				      crseen ? "\r\n" : "\n");
	    
	    newbuf = xmalloc (*buflen + strlen(instruction) + 1);
	    
	    memcpy (newbuf, buf, cp - buf);
	    memcpy (newbuf + (cp - buf), instruction, strlen(instruction));
	    memcpy (newbuf + (cp - buf) + strlen(instruction),
		    cp, *buflen - (cp - buf));
	    
	    msg ("Modified buffer: '%s'", newbuf);

	    free (*bufp);
	    *bufp = newbuf;
	    *buflen += strlen(instruction);
	    
	    return;
	}
    }
}
