/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

void incr_client_count () {
    unsigned totclients = 0;
    int i;

    if (program_stage != stage_serving)
	return;
    
    if (current_backend >= 0) {
	lock_reporter();
	servicereport->backendstate[current_backend].nclients++;
	servicereport->backendstate[current_backend].totuses++;
	for (i = 0; i < activeservice->nbackend; i++)
	    totclients +=
		servicereport->backendstate[i].nclients;
	servicereport->nclients = totclients;
	unlock_reporter();
	
	msg ("extcmd-onstart: "
	     " current_backend = %d, clients = %d, totclients = %d, cmd = %s",
	     current_backend,
	     servicereport->backendstate[current_backend].nclients,
	     servicereport->nclients, 
	     activeservice->backend[current_backend].onstart ?
	     activeservice->backend[current_backend].onstart : "<none>");
    
	sysrun (activeservice->backend[current_backend].onstart);

	msg ("Activity on back end %d now %d, total %d",
	     current_backend,
	     servicereport->backendstate[current_backend].nclients,
	     totclients);
    }
}    
