/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

int init_sockaddr (struct sockaddr_in *name,
                    const char *hostname, int port) {
    struct in_addr *hostaddr;

    if (program_stage != stage_retrying)
	msg ("trying to connect to backend %s:%d", hostname, port);
    name->sin_family = AF_INET;
    name->sin_port = htons (port);
    if (! (hostaddr = dns (hostname)) )
	return (1);
    name->sin_addr = *hostaddr;
    return (0);
}
