/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

int ipf_allowed () {
    int i;

    /* Always allow a connection when we ddon't have an allow list. */
    if (! activeservice->allowchain) {
	msg ("No allow chain (allowing client)");
	return (1);
    }

    /* Try all in the chain. */
    for (i = 0; i < activeservice->nallowchain; i++) {
	msg ("Testing allow rule %d", i);
	if (ipf_match (activeservice->allowchain[i])) {
	    msg ("Allowing client (rule %d)", i);
	    return (1);
	}
    }

    /* Allow chain doesn't match */
    msg ("Not allowing client due to non-match of allow chain");
    return (0);
}
