/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

int ipf_match (IpFilter f) {
    unsigned f_ip_and_mask = f.ip & f.mask;
    unsigned c_ip_and_mask = client_ip_nr & f.mask;
    unsigned res = f_ip_and_mask == c_ip_and_mask;
    
    msg ("IP match: filter IP 0x%8.8x/0x%8.8x (0x%8.8x), "
	 "client IP 0x%8.8x/0x%8.8x (0x%8.8x), comparison %d",
	 f.ip, f.mask, f_ip_and_mask,
	 client_ip_nr, f.mask, c_ip_and_mask,
	 res);
    return (res);
}
