/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

int ipf_parse (char const *val, IpFilter *res) {
    char *str, *cp, *last = (char *) ipf_parse;
    int counter, nr, i;
    
    memset (res, 0, sizeof(IpFilter));
    str = xstrdup (val);

    for (counter = 0, cp = strtok_r (str, ".", &last);
	 cp;
	 counter += 8, cp = strtok_r (0, ".", &last)) {
	if (counter > 24) {
	    warning ("Invalid IP filter specifier '%s' "
		     "(too many network bytes)", val);
	    free (str);
	    return (1);
	}	
	if (sscanf (cp, "%d", &nr) < 1) {
	    warning ("Invalid IP filter specifier '%s' "
		     "('%s' not a number)", val, cp);
	    free (str);
	    return (2);
	}
	nr <<= counter;
	res->ip |= nr;
    }
    free (str);

    if ( (cp = strchr (val, '/')) ) {
	if (sscanf (cp + 1, "%d", &nr) < 1) {
	    warning ("Invalid IP filter specifier '%s' "
		     "(bad mask '%s')", val, cp + 1);
	    return (3);
	}
	for (i = 1; i <= nr; i++) {
	    res->mask <<= 1;
	    res->mask |= 1;
	}
    } else
	res->mask = (unsigned) -1;

    return (0);
}
	
    
