/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "../crossroads.h"

void lock_reporter() {
    static int warning_issued = 0;
    struct sembuf buf[] = {
	{
	    0,		/* semaphore number */
	    0,		/* wait for zero */
	    0,		/* no special flags */
	}, 
	{
	    0,		/* semaphore number */
	    1, 		/* add 1 to the value */
	    0		/* no special flags */
	}
    };
    
    /* msg ("Locking reporter memory"); */
    if ( (!warning_issued++) && (semop (semid, buf, 2) < 0) ) {
	warning ("Failed to lock reporter memory (stage %s): %s",
		 stage_to_string (program_stage), strerror(errno));
	if (program_stage != stage_serving)
	    _exit (1);
	else
	    warning (".. but continuing serving this TCP connection");
    }
}
