/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

void msg (char const *fmt, ...) {
    va_list args;
    char *str;

    if (!flag_verbose || !fmt || !*fmt)
	return;
    va_start (args, fmt);
    str = str_vprintf (fmt, args);
    if (!daemonized) {
	if (activeservice)
	    fprintf (stderr, "INFO: Service %s: %s\n", activeservice->name, str);
	else
	    fprintf (stderr, "INFO: Crossroads: %s\n", str);
    } else {
	if (activeservice)
	    writelog (LOG_NOTICE, "INFO: Service %s: %s",
		      activeservice->name, str);
	else
	    writelog (LOG_NOTICE, "INFO: Crossroads: %s", str);
    }
    free (str);
    va_end (args);
}
