/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "../crossroads.h"

void msgdumpbuf (unsigned char const *buf, int buflen) {
    char
	hexbuf[80] = { 0 },
	disp[17] = { 0 },
	tmp[5];
    int i, j, n = 0;
    
    if (! flag_verbose)
	return;

    for (i = 0; i < buflen; i++) {
	if (! n)
	    snprintf (hexbuf, 80, "%8.8x ", i);
	
	snprintf (tmp, 5, " %2.2x", buf[i]);
	strlcat (hexbuf, tmp, 80);
	
	disp[n] = isprint (buf[i]) ? buf[i] : '.';
	disp[n + 1] = 0;

	if (++n == 16) {
	    strlcat (hexbuf, " ", 80);
	    strlcat (hexbuf, disp, 80);
	    msg ("Message hexdump: %s", hexbuf);
	    n = 0;
	    disp[0] = 0;
	    hexbuf[0] = 0;
	}
    }

    if (n < 16 - 1) {
	for (j = n; j < 16; j++)
	    strlcat (hexbuf, "   ", 80);
	strlcat (hexbuf, " ", 80);
	strlcat (hexbuf, disp, 80);
	msg ("Message hex end: %s", hexbuf);
    }
    else
	msg ("Message hex ends");
}

