/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

unsigned char *net_buffer (CopyDirection dir, unsigned *sz) {
    if (dir == dir_server_to_client) {
	if (srbufmax) {
	    *sz = srbufmax - srbufpos;
	    msg ("%d bytes still in server buffer", *sz);
	    srbufmax = 0;
	    return (srbuf + srbufpos);
	} else {
	    msg ("server buffer is empty");
	    return (0);
	}
    } else {
	if (clbufmax) {
	    *sz = clbufmax - clbufpos;
	    msg ("%d bytes still in client buffer", *sz);
	    clbufmax = 0;
	    return (clbuf + clbufpos);
	} else {
	    msg ("client buffer is empty");
	    return (0);
	}
    }
}
