/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

void options_read (int fd) {
    int res;

    if ( (res = read (fd, &opt, sizeof(Options))) != sizeof(Options) )
	error ("Received only %d bytes (out of %d) "
	       "while reading options on fd %d",
	       res, (int)sizeof(Options), fd);

#   ifdef DEBUG    
    printf ("Option log_activity: %d\n", opt.log_activity);
    printf ("Option tcp_bufsz: %u\n", opt.tcp_bufsz);
    printf ("Option dns_cachettl: %d\n", opt.dns_cachettl);
    printf ("Option log_facility: %d\n", opt.log_facility);
    printf ("Option shmperm: %d\n", opt.shmperm);
    printf ("Option sloppyportbind: %d\n", opt.sloppyportbind);
    printf ("Option leave_proctitle: %d\n", opt.leave_proctitle);
    printf ("Option log_http_activity: %d\n", opt.log_http_activity);
#   endif    
}
