/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

int parser_close () {
    int remaining = 0;
    
    nparserstate--;
    if (nparserstate > 0) {
	/* We still have files in the parserstate stack. Set up yyin and
	 * yylineno, and return 0 to signal that yyin has been set up
	 * again. */
	yyin     = parserstate[nparserstate - 1].file;
	yylineno = parserstate[nparserstate - 1].lineno;
	if (parserstate[nparserstate - 1].buf &&
	    *parserstate[nparserstate - 1].buf)
	    remaining = strlen(parserstate[nparserstate - 1].buf);
	msg ("Returning to configuration '%s' (line %d), %d bytes remain",
	     parserstate[nparserstate - 1].name, yylineno, remaining);	
	return (0);
    }

    /* The parser stack is empty. Return 1 to signal that we're really done. */
    return (1);
}
