/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

/* #define DEBUG */

int parser_input (char *buf, int max) {
    int i, ndef = 0;
    char *cp, *newbuf;

    if (! nparserstate 				||
	! parserstate[nparserstate - 1].buf 	||
	! *parserstate[nparserstate - 1].buf)
	return (0);

    for (i = 0; i < nsymtab; i++) {
	if (!strncmp (parserstate[nparserstate - 1].buf, symtab[i].symbol,
		      strlen(symtab[i].symbol))) {
	    if (ndef++ >= DEF_MAX)
		error ("Too many #defines (%d) at %s (circular definition?",
		       ndef, symtab[i].symbol);
	    cp = parserstate[nparserstate - 1].buf + strlen(symtab[i].symbol);
	    newbuf = xstrdup (symtab[i].redef);
	    newbuf = xstrcat (newbuf, cp);
	    free (parserstate[nparserstate - 1].buf);
	    parserstate[nparserstate - 1].buf = newbuf;
	}
    }

    *buf = *parserstate[nparserstate - 1].buf;
    #ifdef DEBUG
    fprintf (stderr, "LEXER input char: %c (%d)\n", *buf, *buf);
    #endif
    parser_skipchar();
    return (1);
}
