/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

/* This defines setproctitle() incase your system lacks it. */

#if HAVE_SETPROCTITLE == 0

extern char **environ;

void setproctitle (char const *fmt, ...) {
#if SET_PROC_TITLE_BY_ARGV == 1    
    int i;
    char buf[SPT_BUFSIZE], **envp;
    va_list ap;
    static int argv_lth = -1;

    if (argv_lth == -1) {
	/* First time around. Save the environment, initialize. */
	envp = environ;
	for (i = 0; envp[i]; i++)
	    ;
	environ = xmalloc (sizeof(char*) * (i + 1));
	for (i = 0; envp[i]; i++)
	    environ[i] = xstrdup(envp[i]);
	environ[i] = 0;

	if (i)
	    argv_lth = envp[i - 1] + strlen(envp[i - 1]) - org_argv[0];
	else
	    argv_lth = org_argv[org_argc - 1] +
		strlen(org_argv[org_argc - 1]) - org_argv[0];
    }

    /* Prepare the new commandline */
    va_start (ap, fmt);
    vsnprintf (buf, SPT_BUFSIZE, fmt, ap);
    va_end (ap);

    /* Determine max length */
    i = strlen (buf);
    if (i > argv_lth - 2) {
	i = argv_lth - 2;
	buf[i] = 0;
    }

    /* Set into original argv[0] */
#if HAVE_PROGNAME_FULL == 1
    strcpy (__progname_full, buf);
#else    
    memset (org_argv[0], 0, argv_lth);
    strcpy (org_argv[0], buf);
#endif /* HAVE_PROGNAME_FULL */
    
    org_argv[1] = 0;
#endif /* SET_PROC_TITLE_BY_ARGV */    
}

#endif /* HAVE_SETPROCTITLE */

