/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

#define SHOWDEF(a,b,c) 							\
    printf ("%-22s %-31s: %s \n", b, c, a ? "yes" : "no");		

void show_config () {
    printf ("VER                    version:                        %s\n"
            "REVVER                 revision version:               %s\n"
            "YEARS                  it's been around since:         %s\n"
            "AUTHORNAME             author:                         %s\n"
            "MAINTAINERNAME         maintainer:                     %s\n"
            "MAINTAINEREMAIL        e-mail of maintainer:           %s\n"
	    "FQDN_LENGTH            max length of a hostname:       %d\n"
            "SLEEP_TIME             service inactivy pause:         %d\n"
	    "DEF_MAX                max nr of defines in a file     %d\n"
            "DNS_CACHESIZE          size of the DNS cache:          %d\n"
            "DNS_CACHETTL           default ttl of cached DNS:      %d\n"
            "CONNECT_TIMEOUT        backend connect timeout:        %d\n"
            "RETRY_WAIT             backend retry pause:            %d\n"
            "DEFAULT_TCP_BUFSZ      default network buffer size:    %d\n"
            "PREFIX                 installation tree prefix:       %s\n"
            "BINDIR                 directory for binaries:         %s\n"
	    "DEFAULT_SPT_BUFSIZE    default cmdline length:         %d\n"
	    "SPT_BUFSIZE            used cmdline length:            %d\n"
            "SET_PROC_TITLE_BY_ARGV argv assumed linear array:      %d\n"
            "EXTRALIBS              extra library dependencies:     %s\n"
            "LIBS                   standard library dependencies:  %s\n"
            ,
	    VER, REVVER, YEARS, AUTHORNAME, MAINTAINERNAME,
	    MAINTAINEREMAIL,
	    FQDN_LENGTH, SLEEP_TIME, DEF_MAX,
	    DNS_CACHESIZE, DNS_CACHETTL, 
	    CONNECT_TIMEOUT, RETRY_WAIT, DEFAULT_TCP_BUFSZ, PREFIX, BINDIR,
	    DEFAULT_SPT_BUFSIZE, SPT_BUFSIZE,
	    SET_PROC_TITLE_BY_ARGV, EXTRALIBS, LIBS);
    SHOWDEF (HAVE_MALLOC_H,     "HAVE_MALLOC_H",     "<malloc.h> present");
    SHOWDEF (HAVE_STDINT_H,     "HAVE_STDINT_H",     "<stdint.h> present");
    SHOWDEF (HAVE_FLOCK,        "HAVE_FLOCK",        "flock() present");
    SHOWDEF (HAVE_LOCKF,        "HAVE_LOCKF",        "lockf() present");
    SHOWDEF (HAVE_STRLCAT,      "HAVE_STRLCAT",      "strlcat() present");
    SHOWDEF (HAVE_SRANDDEV,     "HAVE_SRANDDEV",     "sranddev() present");
    SHOWDEF (HAVE_VSYSLOG,      "HAVE_VSYSLOG",      "vsyslog() present");
    SHOWDEF (HAVE_STRUPR,   	"HAVE_STRUPR",       "strupr() present");
    SHOWDEF (HAVE_STRCASESTR,   "HAVE_STRCASESTR",   "strcasestr() present");
    SHOWDEF (HAVE_SETPROCTITLE, "HAVE_SETPROCTITLE", "setproctitle() present");
    SHOWDEF (HAVE_STRNSTR,	"HAVE_STRNSTR",	     "strnstr() present");
    SHOWDEF (HAVE_PROGNAME_FULL,"HAVE_PROGNAME_FULL","__progname_full present");
}
