/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#if HAVE_STRLCAT == 0

#include "../crossroads.h"

size_t strlcat (char *dst, char const *src, size_t size) {
    size_t bytes = 0;
    char *q = dst;
    char const *p = src;
    char ch;
    
    while ( bytes < size && *q ) {
	q++;
	bytes++;
    }
    while ( (ch = *p++) ) {
	if ( bytes < size )
	    *q++ = ch;
	bytes++;
    }
    *q = '\0';
    return bytes;
}  

#endif
