/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "../crossroads.h"

#if HAVE_STRNSTR == 0
char *strnstr (char const *big, char const *little, size_t len) {
    int i, max, llen;

    /* Check that we have strings */
    if (!big)
	return (0);
    if (!little)
	return ( (char*) big);

    /* Get lengths */
    llen = strlen(little);
    max = strlen(big) - llen;

    /* Check that big is bigger */
    if (max < 1)
	return (0);

    /* Do the search */
    for (i = 0; i <= max; i++)
	if (!strncmp (big + i, little, llen))
	    return ((char*)(big + i));

    /* Nothing found... */
    return (0);
}
#endif
