/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "../crossroads.h"

#define STR_BLOCK 512

char *str_vprintf (char const *fmt, va_list arguments) {
    int size = STR_BLOCK;	    /* initial size guess */
    char *buffer = xmalloc (size);   /* initial buffer */
    int nchars;			    /* return value of vsnprintf */

    while (1) {			    /* try to make string */
	nchars = vsnprintf (buffer, size, fmt, arguments);

	/* if this worked, return string */
	if (nchars > -1 && nchars < size)
	    return (buffer);

	/* try again with more space */
	if (nchars > -1)
	    size = nchars + 1;
	else
	    size += STR_BLOCK;

	buffer = xrealloc (buffer, size);
    }

    return (0);			    /* to satisfy prototype */
}
