/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "../crossroads.h"

void trafficlog (unsigned char const *buf, int len, CopyDirection dir) {
    int i, j, n = 0;
    char disp[17];
    FILE *f;

    if (current_backend < 0 ||
	! activeservice->backend[current_backend].dumpfile ||
	! *activeservice->backend[current_backend].dumpfile)
	return;

    if ( (! (f = fopen (activeservice->backend[current_backend].dumpfile,
			"a"))) &&
	 (! (f = fopen (activeservice->backend[current_backend].dumpfile,
			"w"))) ) {
	warning ("Cannot write %s: %s",
		 activeservice->backend[current_backend].dumpfile,
		 strerror(errno));
	return;
    }

#if HAVE_FLOCK == 1
    flock (fileno(f), LOCK_EX);
#elif HAVE_LOCKF == 1
    lockf (fileno(f), F_LOCK, 0);
#endif    
    
    for (i = 0; i < len; i++) {
	if (! n) 
	    fprintf (f, "%4.4d %c %4.4x ", getpid(),
		     dir == dir_client_to_server ? 'C' : 'B', i);
	fprintf (f, " %2.2x", buf[i]);
	disp[n] = isprint(buf[i]) ? buf[i] : '.';

	n++;

	if (n == 16) {
	    fputc (' ', f);
	    for (j = 0; j < n; j++)
		fputc (disp[j], f);
	    fputc ('\n', f);
	    n = 0;
	}
    }

    for (j = n; j < 16; j++)
	fprintf (f, "   ");
    fputc (' ', f);
    for (j = 0; j < n; j++)
	fputc (disp[j], f);
    fputc ('\n', f);
    
#if defined HAVE_FLOCK    
    flock (fileno(f), LOCK_UN);
#elif defined HAVE_LOCKF
    lockf (fileno(f), F_ULOCK, 0);
#endif

    fclose (f);
}
