/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "../crossroads.h"

void unlock_reporter() {
    static int warning_issued = 0;
    
    struct sembuf buf = {
	0,		/* semaphore number */
	-1,		/* subtract 1 */
	0,		/* no special flags */
    };

    /* msg ("UnLocking reporter memory"); */
    if ( (! warning_issued++) && (semop (semid, &buf, 1) < 0) ) {
	warning ("Failed to unlock reporter memory (stage %s): %s",
		 stage_to_string (program_stage), strerror(errno));
	if (program_stage != stage_serving)
	    _exit (1);
	else
	    warning (".. but continuing serving this TCP connection");
    }
}
