/*************************************************************************
 * This file is part of Crosroads 1.79, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "../crossroads.h"

void *xrealloc (void *block, unsigned sz) {
    void *newblock;

    /* msg ("Realloc: block=%x, sz=%u", block, sz); */
    if (! sz) {
	free (block);
	newblock = 0;
	/* msg ("Realloc: freed %x", block); */
    } else if (!block) {
	if (! (newblock = malloc (sz)) )
	    error ("Out of memory (while allocating %u bytes)", sz);
	/* msg ("Realloc: malloc'd %x (%u bytes)", newblock, sz); */
    } else {
	if (! (newblock = realloc (block, sz)) )
	    error ("Out of memory (while increasing block to %u bytes)", sz);
	/*  msg ("Realloc'd %x to %x (%u bytes)", block, newblock, sz); */
    }
    return (newblock);
}
   
